"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ehomeRcm = require("ehome-rcm");

var _cycle_big = _interopRequireDefault(require("./assets/animation-json/black/cycle_big.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var noop = function noop() {};

var StaticRenderer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StaticRenderer, _React$Component);

  function StaticRenderer() {
    _classCallCheck(this, StaticRenderer);

    return _possibleConstructorReturn(this, _getPrototypeOf(StaticRenderer).apply(this, arguments));
  }

  _createClass(StaticRenderer, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.shouldUpdate;
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, this.props.render());
    }
  }]);

  return StaticRenderer;
}(_react["default"].Component);

function setTransform(nodeStyle, value) {
  nodeStyle.transform = value;
  nodeStyle.webkitTransform = value;
  nodeStyle.MozTransform = value;
}

var isWebView = typeof navigator !== 'undefined' && /(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(navigator.userAgent);
var DOWN = 'down';
var UP = 'up';
var supportsPassive = false;

try {
  var opts = Object.defineProperty({}, 'passive', {
    get: function get() {
      supportsPassive = true;
    }
  });
  window.addEventListener('test', null, opts);
} catch (e) {// empty
}

var willPreventDefault = supportsPassive ? {
  passive: false
} : false; // const willNotPreventDefault = supportsPassive ? { passive: true } : false;

var ListView =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(ListView, _React$Component2);

  function ListView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ListView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ListView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      refreshSt: 'deactivate',
      loadSt: 'deactivate',
      dragOnEdge: false,
      damping: 120,
      showNoMoreData: false
    });

    _defineProperty(_assertThisInitialized(_this), "_isMounted", false);

    _defineProperty(_assertThisInitialized(_this), "shouldUpdateChildren", false);

    _defineProperty(_assertThisInitialized(_this), "getContainer", function () {
      var useBodyScroll = _this.props.useBodyScroll;
      return useBodyScroll ? document.body : _this.containerRef;
    });

    _defineProperty(_assertThisInitialized(_this), "triggerPullTo", function () {
      var _this$props = _this.props,
          pullToRefresh = _this$props.pullToRefresh,
          pullToLoad = _this$props.pullToLoad,
          refreshing = _this$props.refreshing,
          loading = _this$props.loading,
          direction = _this$props.direction;
      var damping = _this.state.damping; // 在初始化时、用代码 自动 触发 pullToRefresh
      // 注意：当 direction 为 up 时，当 visible length < content length 时、则看不到效果
      // 添加this._isMounted的判断，否则组件一实例化，refreshSt就会是finish

      if (!_this.state.dragOnEdge && _this._isMounted) {
        if (pullToRefresh && refreshing) {
          if (direction === UP) {
            _this._lastScreenY = -damping - 1;
          }

          if (direction === DOWN) {
            _this._lastScreenY = damping + 1;
          } // change dom need after setState


          _this.setState({
            refreshSt: 'release',
            loadSt: 'finish'
          }, function () {
            return _this.setContentStyle(_this._lastScreenY);
          });
        } else if (pullToLoad && loading) {
          if (direction === UP) {
            _this._lastScreenY = damping + 1;
          }

          if (direction === DOWN) {
            _this._lastScreenY = -damping - 1;
          } // change dom need after setState


          _this.setState({
            refreshSt: 'finish',
            loadSt: 'release'
          }, function () {
            return _this.setContentStyle(_this._lastScreenY);
          });
        } else {
          _this.setState({
            refreshSt: 'finish',
            loadSt: 'finish'
          }, function () {
            return _this.reset();
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "init", function (ele) {
      if (!ele) {
        // like return in destroy fn ???!!
        return;
      }

      _this._to = {
        touchstart: _this.onTouchStart.bind(_assertThisInitialized(_this), ele),
        touchmove: _this.onTouchMove.bind(_assertThisInitialized(_this), ele),
        touchend: _this.onTouchEnd.bind(_assertThisInitialized(_this), ele),
        touchcancel: _this.onTouchEnd.bind(_assertThisInitialized(_this), ele)
      };
      Object.keys(_this._to).forEach(function (key) {
        ele.addEventListener(key, _this._to[key], willPreventDefault);
      });

      if (ele && ele === document.body) {
        document.addEventListener('scroll', _this.onScroll.bind(_assertThisInitialized(_this), ele));
      } else {
        ele.addEventListener('scroll', _this.onScroll.bind(_assertThisInitialized(_this), ele));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "destroy", function (ele) {
      if (!_this._to || !ele) {
        // componentWillUnmount fire before componentDidMount, like forceUpdate ???!!
        return;
      }

      Object.keys(_this._to).forEach(function (key) {
        ele.removeEventListener(key, _this._to[key]);
      });

      if (ele && ele === document.body) {
        document.removeEventListener('scroll', _this.onScroll);
      } else {
        ele.removeEventListener('scroll', _this.onScroll);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onTouchStart", function (_ele, e) {
      _this._ScreenY = _this._startScreenY = e.touches[0].screenY; // 一开始 refreshing 为 true 时 this._lastScreenY 有值

      _this._lastScreenY = _this._lastScreenY || 0;
    });

    _defineProperty(_assertThisInitialized(_this), "isEdge", function (ele, direction) {
      if (ele && ele === document.body) {
        // In chrome61 `document.body.scrollTop` is invalid
        var scrollNode = document.scrollingElement ? document.scrollingElement : document.body;

        if (direction === UP) {
          return scrollNode.scrollHeight - scrollNode.scrollTop <= window.innerHeight;
        }

        if (direction === DOWN) {
          return scrollNode.scrollTop <= 0;
        }
      }

      if (direction === UP) {
        return ele.scrollHeight - ele.scrollTop === ele.clientHeight;
      }

      if (direction === DOWN) {
        return ele.scrollTop <= 0;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "isScrollable", function (ele) {
      if (ele && ele === document.body) {
        // In chrome61 `document.body.scrollTop` is invalid
        var scrollNode = document.scrollingElement ? document.scrollingElement : document.body;
        return scrollNode.scrollHeight > window.innerHeight;
      }

      return ele.scrollHeight > ele.clientHeight;
    });

    _defineProperty(_assertThisInitialized(_this), "damping", function (dy) {
      if (Math.abs(_this._lastScreenY) > _this.state.damping) {
        return 0;
      }

      var ratio = Math.abs(_this._ScreenY - _this._startScreenY) / window.screen.height;
      dy *= (1 - ratio) * _this.props.scale;
      return dy;
    });

    _defineProperty(_assertThisInitialized(_this), "onTouchMove", function (ele, e) {
      // 使用 pageY 对比有问题
      var _screenY = e.touches[0].screenY;
      var _this$props2 = _this.props,
          pullToRefresh = _this$props2.pullToRefresh,
          pullToLoad = _this$props2.pullToLoad,
          direction = _this$props2.direction,
          refreshing = _this$props2.refreshing,
          loading = _this$props2.loading,
          noMoreData = _this$props2.noMoreData;
      var showNoMoreData = _this.state.showNoMoreData; // 当前还在加载中时，不做处理

      if (refreshing || loading) return;
      var loadDirection = direction === DOWN ? UP : DOWN;
      var moveDirection;

      if (_screenY > _this._startScreenY) {
        moveDirection = DOWN;
      } else if (_screenY < _this._startScreenY) moveDirection = UP;

      if (pullToRefresh && direction === moveDirection && _this.isEdge(ele, direction)) {
        if (!_this.state.dragOnEdge) {
          // 当用户开始往上滑的时候isEdge还是false的话，会导致this._ScreenY不是想要的，只有当isEdge为true时，再上滑，才有意义
          // 下面这行代码解决了上面这个问题
          _this._ScreenY = _this._startScreenY = e.touches[0].screenY;

          _this.setState({
            dragOnEdge: true
          });
        }

        e.preventDefault();

        var _diff = Math.round(_screenY - _this._ScreenY);

        _this._ScreenY = _screenY;
        _this._lastScreenY += _this.damping(_diff);

        _this.setContentStyle(_this._lastScreenY);

        if (Math.abs(_this._lastScreenY) < _this.props.distanceToRefresh) {
          if (_this.state.refreshSt !== 'deactivate') {
            // console.log('back to the distance');
            _this.setState({
              refreshSt: 'deactivate'
            });
          }
        } else if (_this.state.refreshSt === 'deactivate') {
          // console.log('reach to the distance');
          _this.setState({
            refreshSt: 'activate'
          });
        } // iOS UIWebView issue, It seems no problem in WKWebView


        if (isWebView && e.changedTouches[0].clientY < 0) {
          _this.onTouchEnd();
        }
      } else if (pullToLoad && !showNoMoreData && loadDirection === moveDirection && _this.isEdge(ele, loadDirection)) {
        // 当滑动方向为向上且页面可滑动时，交由onScroll来处理
        if (loadDirection === UP && _this.isScrollable(ele)) {
          _this._ScreenY = _screenY;
          return;
        } // 只处理向上滑动加载


        if (noMoreData) {
          _this.showNoMoreData();

          return;
        }

        if (!_this.state.dragOnEdge) {
          _this._ScreenY = _this._startScreenY = e.touches[0].screenY;

          _this.setState({
            dragOnEdge: true
          });
        }

        e.preventDefault();

        var _diff2 = Math.round(_screenY - _this._ScreenY);

        _this._ScreenY = _screenY;
        _this._lastScreenY += _this.damping(_diff2);

        _this.setContentStyle(_this._lastScreenY);

        _this.setState({
          loadSt: 'activate'
        }); // iOS UIWebView issue, It seems no problem in WKWebView


        if (isWebView && e.changedTouches[0].clientY < 0) {
          _this.onTouchEnd();
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onTouchEnd", function (ele) {
      // 使用 pageY 对比有问题
      var _screenY = _this._ScreenY;
      var _this$props3 = _this.props,
          direction = _this$props3.direction,
          refreshing = _this$props3.refreshing,
          loading = _this$props3.loading;
      var _this$state = _this.state,
          dragOnEdge = _this$state.dragOnEdge,
          refreshSt = _this$state.refreshSt,
          loadSt = _this$state.loadSt; // 当前还在加载中时，不做处理

      if (refreshing || loading) return;
      var loadDirection = direction === DOWN ? UP : DOWN;
      var moveDirection;

      if (_screenY > _this._startScreenY) {
        moveDirection = DOWN;
      } else if (_screenY < _this._startScreenY) moveDirection = UP;

      if (loadDirection === moveDirection && loadDirection === UP && _this.isScrollable(ele)) return;

      if (dragOnEdge) {
        _this.setState({
          dragOnEdge: false
        });
      }

      if (refreshSt === 'activate') {
        _this.refresh();
      } else if (loadSt === 'activate') {
        _this.loadMore();
      } else {
        _this.reset();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onScroll", function (ele, e) {
      var _this$props4 = _this.props,
          direction = _this$props4.direction,
          pullToLoad = _this$props4.pullToLoad,
          noMoreData = _this$props4.noMoreData,
          refreshing = _this$props4.refreshing,
          loading = _this$props4.loading;
      var _this$state2 = _this.state,
          showNoMoreData = _this$state2.showNoMoreData,
          damping = _this$state2.damping;
      var loadDirection = direction === DOWN ? UP : DOWN; // 当前还在加载中时，不做处理

      if (refreshing || loading) return; // 只处理向下滑动加载

      if (pullToLoad && !showNoMoreData && loadDirection === UP && _this.isEdge(ele, loadDirection)) {
        if (noMoreData) {
          _this.showNoMoreData();

          return;
        }

        _this._lastScreenY = -damping - 1; // 让 indicator 的出现具有动画效果

        _this.setState({
          dragOnEdge: true
        }, function () {
          return _this.setContentStyle(_this._lastScreenY);
        });

        setTimeout(function () {
          _this.setState({
            dragOnEdge: false
          });
        }, 300);

        _this.loadMore();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "refresh", function () {
      var _this$props5 = _this.props,
          refreshing = _this$props5.refreshing,
          loading = _this$props5.loading;
      if (refreshing || loading) return;

      _this.setState({
        refreshSt: 'release',
        showNoMoreData: false
      });

      _this._timer = setTimeout(function () {
        if (!_this.props.refreshing) {
          _this.setState({
            refreshSt: 'finish'
          }, function () {
            return _this.reset();
          });
        }

        _this._timer = undefined;
      }, 1000);

      _this.props.onRefresh();
    });

    _defineProperty(_assertThisInitialized(_this), "loadMore", function () {
      var _this$props6 = _this.props,
          refreshing = _this$props6.refreshing,
          loading = _this$props6.loading,
          noMoreData = _this$props6.noMoreData;
      if (refreshing || loading) return;

      _this.setState({
        loadSt: 'release'
      });

      _this._timer = setTimeout(function () {
        if (!_this.props.loading) {
          console.log(1);

          _this.setState({
            loadSt: 'finish'
          }, function () {
            return _this.reset();
          });
        }

        _this._timer = undefined;
      }, 1000);
      if (!noMoreData) _this.props.onLoadMore();
    });

    _defineProperty(_assertThisInitialized(_this), "showNoMoreData", function () {
      _this.setState({
        showNoMoreData: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "reset", function () {
      _this._lastScreenY = 0;

      _this.setContentStyle(0);
    });

    _defineProperty(_assertThisInitialized(_this), "setContentStyle", function (ty) {
      // todos: Why sometimes do not have `this.contentRef` ?
      if (_this.contentRef) {
        setTransform(_this.contentRef.style, "translate3d(0px,".concat(ty, "px,0)"));
      }
    });

    return _this;
  }

  _createClass(ListView, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      this.shouldUpdateChildren = this.props.children !== nextProps.children;
      return true;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props7 = this.props,
          refreshing = _this$props7.refreshing,
          loading = _this$props7.loading,
          noMoreData = _this$props7.noMoreData;

      if (prevProps.refreshing !== refreshing || prevProps.loading !== loading) {
        this.triggerPullTo();
      }

      if (prevProps.noMoreData && !noMoreData) {
        this.setState({
          showNoMoreData: false
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      // `getContainer` most likely return React.Node at the next tick. Need setTimeout
      setTimeout(function () {
        _this2.init(_this2.getContainer());

        _this2.triggerPullTo();

        _this2._isMounted = true;
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // Should have no setTimeout here!
      this.destroy(this.getContainer());
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var props = _objectSpread({}, this.props);

      var className = props.className,
          prefixCls = props.prefixCls,
          children = props.children,
          useBodyScroll = props.useBodyScroll,
          direction = props.direction,
          onRefresh = props.onRefresh,
          refreshing = props.refreshing,
          distanceToRefresh = props.distanceToRefresh,
          pullToRefresh = props.pullToRefresh,
          pullToLoad = props.pullToLoad,
          noMoreDataText = props.noMoreDataText,
          restProps = _objectWithoutProperties(props, ["className", "prefixCls", "children", "useBodyScroll", "direction", "onRefresh", "refreshing", "distanceToRefresh", "pullToRefresh", "pullToLoad", "noMoreDataText"]);

      var showNoMoreData = this.state.showNoMoreData;

      var renderChildren = _react["default"].createElement(StaticRenderer, {
        shouldUpdate: this.shouldUpdateChildren,
        render: function render() {
          return children;
        }
      });

      var refreshIndicator = _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-indicator")
      }, _react["default"].createElement(_ehomeRcm.LottieAnimation, {
        className: (0, _classnames["default"])("".concat(prefixCls, "-icon")),
        animationData: _cycle_big["default"]
      }));

      var loadCls = (0, _classnames["default"])("".concat(prefixCls, "-indicator-load"), showNoMoreData && "".concat(prefixCls, "-indicator-load-no-more"));

      var loadIndicator = _react["default"].createElement("div", {
        className: loadCls
      }, showNoMoreData ? _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-indicator-load-no-more-text")
      }, noMoreDataText) : _react["default"].createElement(_ehomeRcm.LottieAnimation, {
        className: (0, _classnames["default"])("".concat(prefixCls, "-icon")),
        animationData: _cycle_big["default"]
      }));

      var renderRefresh = function renderRefresh(cls) {
        var cla = (0, _classnames["default"])(cls, !_this3.state.dragOnEdge && "".concat(prefixCls, "-transition"));
        return _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-content-wrapper")
        }, _react["default"].createElement("div", {
          className: cla,
          ref: function ref(el) {
            return _this3.contentRef = el;
          }
        }, pullToRefresh && direction === DOWN ? refreshIndicator : null, pullToLoad && direction === UP ? loadIndicator : null, renderChildren, pullToRefresh && direction === UP ? refreshIndicator : null, pullToLoad && direction === DOWN ? loadIndicator : null));
      };

      if (useBodyScroll) {
        return renderRefresh("".concat(prefixCls, "-content ").concat(prefixCls, "-").concat(direction));
      }

      return _react["default"].createElement("div", _extends({
        ref: function ref(el) {
          return _this3.containerRef = el;
        },
        className: (0, _classnames["default"])(className, prefixCls, "".concat(prefixCls, "-").concat(direction))
      }, restProps), renderRefresh("".concat(prefixCls, "-content")));
    }
  }]);

  return ListView;
}(_react["default"].Component);

exports["default"] = ListView;

_defineProperty(ListView, "defaultProps", {
  prefixCls: 'eh-list-view',
  useBodyScroll: true,
  // 拉动方向，down表示下拉刷新和上滑加载
  direction: DOWN,
  // 是否使用拉动刷新
  pullToRefresh: false,
  // 是否使用滑动加载
  pullToLoad: true,
  noMoreData: false,
  noMoreDataText: '- 没有更多内容 -',
  distanceToRefresh: 25,
  scale: 0.6,
  onRefresh: noop,
  onLoadMore: noop
});

module.exports = exports.default;