"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _PlateNumberItem = _interopRequireDefault(require("./PlateNumberItem"));

var _CustomKeyboard = _interopRequireDefault(require("./CustomKeyboard"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/** 最大可输入车牌号码长度 */
var plateNumberLength = 8;

var PlateNumberInput =
/*#__PURE__*/
function (_Component) {
  _inherits(PlateNumberInput, _Component);

  function PlateNumberInput(_props) {
    var _this;

    _classCallCheck(this, PlateNumberInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PlateNumberInput).call(this, _props));

    _defineProperty(_assertThisInitialized(_this), "updateValueAndCompleted", function (props) {
      var value = props.value,
          onChange = props.onChange;

      var plateNumber = _this.transformValue(value);

      _this.setState({
        plateNumber: plateNumber
      });

      if (onChange) {
        onChange({
          value: plateNumber,
          completed: _this.validateCompleted(plateNumber)
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onKeyboardClick", function (value) {
      var _this$state = _this.state,
          plateNumber = _this$state.plateNumber,
          focusIndex = _this$state.focusIndex,
          energyActivated = _this$state.energyActivated,
          keyboardType = _this$state.keyboardType;
      var newPlateNumber = plateNumber.concat();

      if (value === 'switch') {
        _this.setState({
          keyboardType: keyboardType === 'province' ? 'ABC' : 'province'
        });

        return;
      }

      if (value === 'delete') {
        var currentValue = newPlateNumber[focusIndex];
        if (!currentValue && focusIndex === 0) return;

        if (currentValue || focusIndex === 0) {
          newPlateNumber[focusIndex] = '';
        } else if (focusIndex > 0) {
          newPlateNumber[focusIndex - 1] = '';

          _this.plateNumberItemRefArr[focusIndex].onInputBlur();

          _this.plateNumberItemRefArr[focusIndex - 1].onFakeInputClick();
        }
      } else {
        var maxNextIndex = plateNumberLength - (energyActivated ? 1 : 2);
        newPlateNumber[focusIndex] = value;

        if (focusIndex < maxNextIndex) {
          _this.plateNumberItemRefArr[focusIndex].onInputBlur();

          _this.plateNumberItemRefArr[focusIndex + 1].onFakeInputClick();
        }
      }

      var onChange = _this.props.onChange;

      if (onChange) {
        onChange({
          value: newPlateNumber,
          completed: _this.validateCompleted(newPlateNumber)
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "changeStateFunc", function (params) {
      if (params.focusIndex === plateNumberLength - 1) {
        _this.setState({
          energyActivated: true
        });
      }

      _this.setState(_objectSpread({}, params));
    });

    _defineProperty(_assertThisInitialized(_this), "onKeyboardComplete", function () {
      var focusIndex = _this.state.focusIndex;

      _this.plateNumberItemRefArr[focusIndex].onInputBlur();
    });

    _defineProperty(_assertThisInitialized(_this), "savePlateNumberItem", function (index) {
      return function (el) {
        _this.plateNumberItemRefArr[index] = el;
      };
    });

    _this.plateNumberItemRefArr = [];
    _this.customKeyboard = null;
    _this.state = {
      keyboardType: 'province',
      keyboardVisible: false,
      focusIndex: 0,
      energyActivated: false,
      plateNumber: _this.transformValue([])
    };
    return _this;
  }

  _createClass(PlateNumberInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var defaultFocusIndex = this.props.defaultFocusIndex;

      if (typeof defaultFocusIndex === 'number') {
        if (this.plateNumberItemRefArr[defaultFocusIndex]) {
          this.plateNumberItemRefArr[defaultFocusIndex].onFakeInputClick();
        }
      }

      this.updateValueAndCompleted(this.props);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var oldValue = this.props.value;
      var value = nextProps.value;

      if (!(0, _isEqual["default"])(value, oldValue)) {
        this.updateValueAndCompleted(nextProps);
      }
    }
  }, {
    key: "transformValue",
    value: function transformValue(value) {
      var plateNumber = value.map(function (item) {
        return item.toLocaleUpperCase();
      });
      var fillArr = Array(plateNumberLength - plateNumber.length).fill('');
      return plateNumber.concat(fillArr);
    }
  }, {
    key: "validateCompleted",
    value: function validateCompleted() {
      var plateNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var specialStr = plateNumber[plateNumber.length - 1];
      var completed = false;

      if (specialStr) {
        completed = plateNumber.every(function (value) {
          return !!value.trim();
        });
      } else {
        completed = plateNumber.slice(0, -1).every(function (value) {
          return !!value.trim();
        });
      }

      return completed;
    }
    /**
     * 输入规则:
     * 1、默认定位第一位，输入完后光标自动跳到下一位。输入完第七位时，固定在第七位位置。
     *    第八位需手动点击才能输入，激活后无需多次激活(光标可自动跳到该位置)。
     * 2、可以点击任一位进行输入和修改，光标在输入完后会自动跳到下一位。
     * 3、点击删除时，如果当前位置有值，则删除当前位置内容;如果当前位置没有值时，则删除前一位置内容。
     */

  }, {
    key: "render",
    value: function render() {
      var prefixCls = 'eh-plate-number';
      var _this$props = this.props,
          itemClassName = _this$props.itemClassName,
          useBodyScroll = _this$props.useBodyScroll;
      var _this$state2 = this.state,
          keyboardVisible = _this$state2.keyboardVisible,
          keyboardType = _this$state2.keyboardType,
          plateNumber = _this$state2.plateNumber;

      var separatorIcon = _react["default"].createElement("i", {
        key: "separator-icon",
        className: "".concat(prefixCls, "-separator")
      });

      var plateNumberListEl = [];

      for (var index = 0; index < plateNumberLength; index++) {
        var className = "".concat(prefixCls, "-item-content");
        var childrenEl = null;

        if (index === plateNumberLength - 1) {
          className = "".concat(prefixCls, "-item-energy");
          childrenEl = _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("svg", {
            className: "".concat(prefixCls, "-leaf"),
            viewBox: "0 0 40 38",
            version: "1.1",
            xmlns: "http://www.w3.org/2000/svg",
            xmlnsXlink: "http://www.w3.org/1999/xlink"
          }, _react["default"].createElement("g", {
            stroke: "none",
            strokeWidth: "1",
            fillRule: "evenodd"
          }, _react["default"].createElement("g", {
            fill: "#39bf7c"
          }, _react["default"].createElement("path", {
            d: "M32,23 L35,23 L35,28 L40,28 L40,31 L35,31 L35,36 L32,36 L32,31 L27,31 L27,28 L32,28 L32,23 Z M34.5169021,2.50538279 C34.4478636,2.53608705 34.2153089,2.68604044 33.9372501,2.92446196 C33.4555674,3.33748077 32.9697763,3.89843345 32.5128897,4.62967563 C31.1842665,6.756123 30.3803872,9.8342283 30.3803872,14.0468849 C30.3803872,18.1926669 28.8989681,21.4676462 25.9818613,23.7386554 C22.7821167,26.2298061 18.1783284,27.2950722 12.7384273,27.2950722 C11.8208583,27.2946021 10.9036379,27.2646996 9.99529686,27.2058097 C9.97032129,27.2044165 9.97032129,27.2044165 9.94537362,27.2026127 C8.9743159,27.1283808 8.22497898,26.372859 8.32209213,25.4763094 C8.4176832,24.5938392 9.29450455,23.98012 10.2481329,24.0530607 C15.8898281,24.4097288 20.6683368,23.6632255 23.6194996,21.3658202 C25.7349087,19.717124 26.8081301,17.2689561 26.8081301,14.0458035 C26.8081301,9.07530224 27.8473287,5.3836712 29.5903863,2.78851485 C19.0177983,3.36754574 10.3483417,5.73596501 6.33487315,10.6029361 C4.02754068,13.4000711 3.48937737,16.978502 4.74506521,21.3156682 C7.7654158,16.6264013 11.9036085,12.5175393 17.3462015,9.46974134 C18.1464895,9.01959527 19.2150287,9.19939265 19.7666969,9.89379574 C20.3592193,10.6396234 20.1159039,11.6631596 19.2632497,12.1396461 C14.2685288,14.9367596 10.4530283,18.7869447 7.66251385,23.2096802 C5.98047905,25.8755668 4.86410114,28.5011543 4.60781076,29.543872 C4.36544499,30.3441541 3.48132171,30.8242996 2.5858364,30.6921474 C1.6184224,30.5493753 0.937819814,29.733931 1.12936166,28.8205316 C1.28355925,28.2214257 1.75616772,26.9188669 2.47656058,25.3886212 C-0.445381775,18.7047936 -0.132071806,13.0778564 3.4477159,8.73602157 C8.92420421,2.09532722 20.6295837,-0.431048518 33.7311244,-0.5 L33.7390429,-0.499999959 C34.5454324,-0.499674877 35.2660392,-0.0220902968 35.4696839,0.691167772 C35.6831117,1.43559739 35.2654367,2.18956032 34.5169021,2.50538279 Z"
          })))));
        }

        plateNumberListEl.push(_react["default"].createElement(_PlateNumberItem["default"], {
          key: index,
          index: index,
          ref: this.savePlateNumberItem(index),
          prefixCls: prefixCls,
          className: className,
          itemClassName: itemClassName,
          value: plateNumber[index].trim(),
          changePropsFunc: this.changeStateFunc
        }, childrenEl));
      }

      plateNumberListEl.splice(2, 0, separatorIcon);
      return _react["default"].createElement("div", {
        className: prefixCls
      }, _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-container")
      }, plateNumberListEl), _react["default"].createElement(_CustomKeyboard["default"], {
        useBodyScroll: useBodyScroll,
        visible: keyboardVisible,
        type: keyboardType,
        onClick: this.onKeyboardClick,
        onComplete: this.onKeyboardComplete
      }));
    }
  }]);

  return PlateNumberInput;
}(_react.Component);

_defineProperty(PlateNumberInput, "propTypes", {
  // 是否使用 html 的 body 作为滚动容器
  useBodyScroll: _propTypes["default"].bool,
  itemClassName: _propTypes["default"].string,
  value: _propTypes["default"].arrayOf(_propTypes["default"].string),
  defaultFocusIndex: _propTypes["default"].number,
  onChange: _propTypes["default"].func
});

_defineProperty(PlateNumberInput, "defaultProps", {
  value: [],
  useBodyScroll: false
});

PlateNumberInput.buildValueStr = function () {
  var plateNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  if (!plateNumber.length) return '';

  var hasNonEmptyValue = function hasNonEmptyValue(arr) {
    return arr.some(function (value) {
      return !!value.trim();
    });
  };

  var plateNumberStr = '';
  plateNumber.forEach(function (str, index) {
    if (str === '' && hasNonEmptyValue(plateNumber.slice(index + 1))) {
      plateNumberStr += ' ';
    } else {
      plateNumberStr = "".concat(plateNumberStr).concat(str);
    }
  });
  return plateNumberStr;
};

var _default = PlateNumberInput;
exports["default"] = _default;
module.exports = exports.default;